<div>
	<div id="subheader">
		<div class="nav-right">
			<dx-tabs #subNavbarTabs [height]="ds.tabsHeight" [width]="ds.tabsWidth" (onInitialized)="onInitTabs($event)"
				[dataSource]="subnavTabs" [scrollingEnabled]="true" [scrollByContent]="true" [showNavButtons]="true"
				[selectedIndex]="0" (onItemClick)="reloadData($event)"></dx-tabs>
		</div>
	</div>
	<br />

	<div [hidden]="current == 'tr'">
		<dx-data-grid class="gridContainer" [class.isMob]="ds.isMob" #gridOrder [columnAutoWidth]='true'
			[allowColumnResizing]='true' [allowColumnReordering]='true'
			[rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines'
			[showRowLines]='ds.showRowLines' [dataSource]='dsOrders' [height]='ds.customHeight'
			(onCellPrepared)='onCellPrepared($event)' (onToolbarPreparing)='toolbarPreparing($event)'
			[customizeColumns]='customizeColumns' (onSelectionChanged)='selectionChanged($event)'
			(onContentReady)='onContentReady($event)' (onEditingStart)="onCellEditingStart($event)">

			<dxo-editing mode='cell' [allowUpdating]='true'></dxo-editing>
			<dxo-export [enabled]='true' fileName='orders'></dxo-export>
			<dxo-header-filter [visible]='true'></dxo-header-filter>
			<dxo-filter-row [visible]='true'> </dxo-filter-row>
			<dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
			<dxo-search-panel [visible]='true'></dxo-search-panel>
			<dxo-column-chooser [enabled]='true'></dxo-column-chooser>
			<dxo-column-fixing [enabled]="true"></dxo-column-fixing>
			<dxo-state-storing [enabled]='true' [storageKey]="'gridOrderWST' + current" type="custom"
				[customLoad]="ds.gridLoadState" [customSave]="ds.gridSaveState"></dxo-state-storing>
			<dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>

			<dxi-column caption='Trip' cellTemplate='tripColumn' dataField='t_refNumber' dataType='number' width='60'
				fixedPosition='left' [fixed]='true' [allowResizing]='false'
				[visible]="current === 'ap' || current === 'pg' || current === 'fin'" [allowEditing]="false">
				<div *dxTemplate="let data of 'tripColumn'">
					<a *ngIf="data.data.t_refNumber !== null" class="dx-link" (click)="editTrip(data)">
						{{ data.data.t_refNumber }} </a>
				</div>
			</dxi-column>
			
			<dxi-column caption="Status" dataField='ol_statusId' dataType='string' [visible]='current == "all" && ds.isAdmin()'>
				<dxo-lookup [dataSource]='dsOrderStatus' valueExpr='id' displayExpr='name'></dxo-lookup>
			</dxi-column>
			<dxi-column caption='SO Number' dataField='ol_refNumber' dataType='string' [allowHeaderFiltering]='false'
				[allowEditing]="false" [allowHiding]="false"></dxi-column>
			<dxi-column caption='Customer Code' dataField='c_code' dataType='string' [allowEditing]="false"
				[allowHiding]="false"></dxi-column>
			<dxi-column caption='Customer' dataField='c_name' dataType='string' [allowHeaderFiltering]='false'
				[allowEditing]="false" [allowHiding]="false"></dxi-column>
			<dxi-column caption='Ship to Party' dataField='ca_code' dataType='string' [allowEditing]="false">
			</dxi-column>
			<dxi-column caption='County' dataField='ca_region' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='City' dataField='ca_city' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Depot' dataField='d_name' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Depot Code' dataField='d_code' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Contact' dataField='ol_contact' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Range' dataField='r_value' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Requested Date' dataField='ol_requestDate' dataType='date'
				calculateSortValue='ol_requestDate' [calculateDisplayValue]='ds.getDate' [allowEditing]="false">
				<dxo-header-filter groupInterval='day'></dxo-header-filter>
			</dxi-column>
			<dxi-column caption='Old Requested Date' dataField='ol_oldRequestDate'
				calculateSortValue='ol_oldRequestDate' dataType='date' [calculateDisplayValue]='ds.getDate'
				[allowEditing]="false"></dxi-column>
			<dxi-column caption='Scheduled Date' dataField='ol_scheduledDate' calculateSortValue='ol_scheduledDate'
				dataType='datetime' [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Delivery Date' dataField='ol_deliveryDate' calculateSortValue='ol_deliveryDate'
				dataType='datetime' [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"
				[visible]="current == 'fin'"></dxi-column>
			<dxi-column caption='Product' dataField='p_name' dataType='string' [allowEditing]="false"></dxi-column>
			<dxi-column caption='Quantity L15' dataField='ol_quantity' dataType='number' [allowHeaderFiltering]='false'
				[allowEditing]="current !== 'fin' && current !== 'rej'"></dxi-column>
			<dxi-column caption='Loaded Quantity L15' dataField='ol_loadedQuantity' dataType='number'
				[allowHeaderFiltering]='false' [showInColumnChooser]='false' [allowEditing]='false'></dxi-column>
			<dxi-column caption='Delivered Quantity L15' dataField='ol_deliveredQuantity' dataType='number'
				[allowHeaderFiltering]='false' [allowEditing]='false'></dxi-column>
			<dxi-column caption='Transporter' dataField='tr_name' dataType='string' [visible]='!ds.isTrans()'
				[allowEditing]="false"></dxi-column>
			<dxi-column caption='Address' dataField='ca_description' dataType='string' [allowHeaderFiltering]='false'
				[allowEditing]="false"></dxi-column>
			<dxi-column caption='Truck' dataField='car_registrationNo' dataType='string' [allowEditing]="false">
			</dxi-column>
			<dxi-column caption='Trailer' dataField='tank_registrationNo' dataType='string' [allowEditing]="false">
			</dxi-column>
			<dxi-column caption='Comments' dataField='ol_comments' dataType='string' [allowHeaderFiltering]='false'
				[allowEditing]="false"></dxi-column>

			<dxi-column cellTemplate='map' fixedPosition='right' [fixed]='true'>
				<div *dxTemplate="let data of 'map'" id="mapColumn">
					<dx-button *ngIf='data.data.ca_coordX' class="dx-success" (click)="openMap(data)" icon='map'
						hint='Map' [height]='ds.btnHeight'></dx-button>
				</div>
			</dxi-column>
			<dxi-column cellTemplate='actions' fixedPosition='right' [fixed]='true' [allowResizing]='false'
				[showInColumnChooser]='false'>
				<div *dxTemplate="let data of 'actions'" id="actionsColumn">
					<dx-button class="dx-success" (click)="changeState(1, data)" icon='check' hint='Approve'
						[height]='ds.btnHeight' *ngIf='isApproveVisible'></dx-button>
					<dx-button class="dx-success" (click)="changeState(2, data)" icon='remove' hint='Reject'
						[height]='ds.btnHeight' *ngIf='isRejectVisible'></dx-button>
					<dx-button class="dx-success resq" (click)="changeState(3, data)" icon='event' hint='Reschedule'
						[height]='ds.btnHeight' *ngIf='isRescheduleVisible'></dx-button>
				</div>
			</dxi-column>
		</dx-data-grid>
	</div>

	<div [hidden]="current != 'tr'">
		<dx-data-grid class="gridContainer" [class.isMob]="ds.isMob" #gridTransfer [columnAutoWidth]='true'
			[allowColumnResizing]='true' [allowColumnReordering]='true'
			[rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines'
			[showRowLines]='ds.showRowLines' [dataSource]='dsTripTransfer' [height]='ds.customHeight'
			(onCellPrepared)='onCellPrepared($event)' (onContentReady)='onContentReadyTransfer($event)'
			(onToolbarPreparing)='toolbarPreparingTransfer($event)'>

			<!-- <dxo-editing mode='cell' [allowUpdating]='false'></dxo-editing> -->
			<dxo-export [enabled]='true' fileName='trip_transfers'></dxo-export>
			<dxo-header-filter [visible]='true'></dxo-header-filter>
			<dxo-filter-row [visible]='true'> </dxo-filter-row>
			<dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
			<dxo-search-panel [visible]='true'></dxo-search-panel>
			<dxo-column-chooser [enabled]='true'></dxo-column-chooser>
			<dxo-column-fixing [enabled]="true"></dxo-column-fixing>
			<!-- <dxo-state-storing [enabled]='true' [storageKey]="'gridTransferWST' + current"></dxo-state-storing> -->
			<dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>

			<dxi-column caption="Trip no." dataField="t_refNumber" dataType="number"></dxi-column>
			<dxi-column caption="Transporter" dataField="tr_name" dataType="string"></dxi-column>
			<dxi-column caption="From order" dataField="fo_refNumber" dataType="string"></dxi-column>
			<dxi-column caption="To Order" dataField="to_refNumber" dataType="string"></dxi-column>
			<dxi-column caption="Comments" dataField="to_comments" dataType="string"></dxi-column>
			<!-- <dxi-column caption="Approved date" dataField="tt_approvedDate" dataType="date" calculateSortValue='tt_approvedDate' [calculateDisplayValue]='ds.getDate'></dxi-column> -->
			<dxi-column caption="Quantity" dataField="tt_quantity" dataType="number"></dxi-column>
			<!-- <dxi-column caption="Approved by" dataField="tt_approvedBy" dataType="string"></dxi-column> -->
			<dxi-column caption="Transfer date" dataField="tt_transferDate" dataType="date"
				calculateSortValue='tt_transferDate' [calculateDisplayValue]='ds.getDate'></dxi-column>
			<dxi-column caption="Created by" dataField="tt_createdBy" dataType="string"></dxi-column>
			<dxi-column caption="Product" dataField="p_name" dataType="string"></dxi-column>
			<dxi-column caption="From Ship to Party" dataField="fost_name" dataType="string"></dxi-column>
			<dxi-column caption="From Address" dataField="foca_description" dataType="string"></dxi-column>
			<dxi-column caption="To Ship to Party" dataField="tost_name" dataType="string"></dxi-column>
			<dxi-column caption="To Address" dataField="toca_description" dataType="string"></dxi-column>
			<dxi-column caption="Truck" dataField="car_registrationNo" dataType="string"></dxi-column>

			<dxi-column cellTemplate='actions' fixedPosition='right' [fixed]='true' [allowResizing]='false'
				[showInColumnChooser]='false'>
				<div *dxTemplate="let data of 'actions'" id="actionsColumn">
					<dx-button class="dx-success" (click)="changeTransferState(1, data.data)" icon='check'
						hint='Approve' [height]='ds.btnHeight'></dx-button>
					<dx-button class="dx-success" (click)="changeTransferState(2, data.data)" icon='remove'
						hint='Reject' [height]='ds.btnHeight'></dx-button>
				</div>
			</dxi-column>
		</dx-data-grid>
	</div>
</div>

<dx-popup width='90vw' height='90vh' [position]="ds.popupPosition" [(visible)]='isMapVisible' [showTitle]="true">
	<div *dxTemplate="let data of 'title'">
		<div class="logo-small" style="float:left">
			<img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
		</div>
		<h4>Ship to party: {{ shipToParty }}</h4>
	</div>

	<div *dxTemplate="let data of 'content'">
		<dx-map #map [center]="mapLocation" [routes]='routes' [markers]='markers' [zoom]="10" height="calc(100% - 40px)"
			width="100%" key='AIzaSyCSSJo6UDSFpjMPP8rUuqA4k-6sKSsL4Bc'></dx-map>
		<br />
		<div style="float: right;margin-bottom:20px;">
			<dx-button text='Cancel' (onClick)='cancelClick()' class='redTxt'></dx-button>
		</div>
	</div>
</dx-popup>

<dx-popup title='Order' [(visible)]='isOrderVisible' width='auto' height='auto' [position]="ds.popupPosition">
	<div *dxTemplate="let data of 'title'">
		<div class="logo-small" style="float:left">
			<img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
		</div>
		<h4>Create new order</h4>
	</div>

	<div *dxTemplate="let data of 'content'">
		<dx-form [colCount]="2" (onInitialized)="onFormInit($event)" [formData]='ol' [showValidationSummary]="false"
			validationGroup="orderValidation">
			<dxi-item itemType="group" [colSpan]="2" [colCount]='2'>
				<dxi-item [label]="{text: 'Type'}" dataField="typeId" editorType="dxSelectBox"
					[editorOptions]="typeEditorOpt" [colSpan]="2">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Customer'}" dataField="customerName" editorType="dxTextBox"
					[editorOptions]="{ readOnly: true, value: customerName }" [colSpan]="2"></dxi-item>
				<dxi-item [label]="{text: 'Location'}" dataField="addressId" editorType="dxSelectBox"
					[editorOptions]="{ valueExpr: 'id', displayExpr: 'description' }" [colSpan]="2">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Depot'}" dataField="depotId" editorType="dxSelectBox"
					[editorOptions]="{ dataSource: dsDepot, valueExpr: 'id', displayExpr: 'name' }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Requested Date'}" dataField="requestDate" editorType="dxDateBox"
					[editorOptions]="{ type:'date', displayFormat: 'dd.MM.yyyy' }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Transporter'}" dataField="transporterId" editorType="dxSelectBox"
					[editorOptions]="{ dataSource: dsTransporter, valueExpr: 'id', displayExpr: 'name' }" [colSpan]="2">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Product'}" dataField="productId" editorType="dxSelectBox" [colSpan]="2"
					[editorOptions]="{ dataSource: dsProduct, valueExpr: 'id', displayExpr: 'name' }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Quantity'}" dataField="quantity" editorType="dxNumberBox" [colSpan]="2">
					<dxi-validation-rule type="range" min="1" max="9999999" message="Only positive value allowed.">
					</dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Comments'}" dataField="comments" editorType="dxTextArea" [colSpan]="2"
					[editorOptions]="{ height: 60 }"></dxi-item>
			</dxi-item>
		</dx-form>
		<br />
		<div style="float: right;margin-bottom:20px;">
			<dx-button type='success' text='Save' (onClick)='onSaveOrder($event)' validationGroup="orderValidation">
			</dx-button>
			<dx-button text='Cancel' (onClick)='cancelClick()' class='redTxt'></dx-button>
		</div>

	</div>
</dx-popup>

<dx-popup title='Trip' [(visible)]='isTripVisible' width='auto' height='auto' [position]="ds.popupPosition">
	<div *dxTemplate="let data of 'title'">
		<div class="logo-small" style="float:left">
			<img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
		</div>
		<h4>Create new trip</h4>
	</div>
	<div *dxTemplate="let data of 'content'">
		<dx-form [colCount]="1" [formData]='t' [showValidationSummary]="false" validationGroup="tripValidation">
			<dxi-item itemType="group" [colSpan]="1" [colCount]='1'>
				<dxi-item [label]="{text: 'Loading Date'}" dataField="plannedDate" editorType="dxDateBox"
					[editorOptions]="{ type:'datetime' ,displayFormat: 'dd.MM.yyyy HH:mm', width:'100%', max: t.reqMaxDate, min: t.reqMinDate }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Truck'}" dataField="carId" editorType="dxSelectBox"
					[editorOptions]="{ dataSource: dsTruck, valueExpr: 'id', displayExpr: 'registrationNo', searchEnabled: 'true', onSelectionChanged: onSelectTruck }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Trailer'}" dataField="tankId" editorType="dxSelectBox"
					[editorOptions]="{ dataSource: dsTank, valueExpr: 'id', displayExpr: 'registrationNo', searchEnabled: 'true' }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Driver'}" dataField="driverId" editorType="dxLookup"
					[editorOptions]="{ dataSource: dsDrivers, valueExpr: 'id', pagingEnabled: false, displayExpr: displayDriver, closeOnOutsideClick:true, searchExpr: ['firstName', 'lastName'] }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
			</dxi-item>
		</dx-form>
		<br />
		<div style="float: right;margin-bottom:20px;">
			<dx-button type='success' text='Save' (onClick)='onSaveTrip($event)' validationGroup="tripValidation">
			</dx-button>
			<dx-button text='Cancel' class='redTxt' (onClick)='cancelClick($event)'></dx-button>
		</div>
	</div>
</dx-popup>

<dx-popup title='Assign Transport' [(visible)]='isAssTranspVisible' width='auto' height='auto'
	[position]="ds.popupPosition" titleTemplate="popupTitle" contentTemplate="popupTemplate">
	<div *dxTemplate="let item of 'popupTitle'">
		<div class="logo-small" style="float:left">
			<img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
		</div>
		<h4>Assign orders to a transporter</h4>
	</div>
	<div *dxTemplate="let data of 'popupTemplate'">
		<dx-form [colCount]="1" [formData]='at' [showValidationSummary]="false" validationGroup="assTranspValidation">
			<dxi-item itemType="group" [colSpan]="1" [colCount]='1'>
				<dxi-item [label]="{text: 'Truck'}" dataField="carId" editorType="dxSelectBox"
					[editorOptions]="{ dataSource: dsTruck, valueExpr: 'id', displayExpr: 'registrationNo', onSelectionChanged: onAssignNewCar }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
				<dxi-item [label]="{text: 'Trailer'}" dataField="tankId" editorType="dxSelectBox"
					[editorOptions]="{ dataSource: dsTank, valueExpr: 'id', displayExpr: 'registrationNo' }">
					<dxi-validation-rule type="required"></dxi-validation-rule>
				</dxi-item>
			</dxi-item>
		</dx-form>
		<br />
		<div style="float: right;margin-bottom:20px">
			<dx-button type='success' text='Save' (onClick)='onAssTranspTrip($event)'
				validationGroup="assTranspValidation"></dx-button>
			<dx-button text='Cancel' (onClick)='cancelClick()' class='redTxt'></dx-button>
		</div>
	</div>
</dx-popup>

<app-change-order [isStateVisible]='isStateVisible' [po]='po' [dsMessages]="dsMessages" (save)="acceptClick($event)"
	(cancel)="cancelClick()"></app-change-order>

<app-gas-station [gasVisible]='isGasStationVisible' [gs]='gs' [gsTank]='gsTank' (save)="saveGS($event)"
	(cancel)="cancelGS()" (popupHidden)="cancelGS()">
</app-gas-station>